---
id: introduction
title: Introduction
---

## What is this?

The **Tech Interview Handbook** contains carefully curated content to help you ace your next technical interview with a focus on algorithms. While there are a ton of interview resources on the internet, the best ones are either not free, or they do not cover the complete interview process, usually only focusing on algorithms. Tech Interview Handbook goes straight to the point and tells you the minimum you need to know to pass your technical interviews.

Over 500,000 people have benefitted from this handbook! I have lost count of the number of people who have messaged me on Twitter/LinkedIn to thank the Tech Interview Handbook for helping them in their job hunt.

## Who am I?

In 2017, I was frustrated at my job at Grab, a regional ridehailing company and wanted to break into FAANG but I didn't know how to. After few months of research, studying and practicing, I interviewed at 11 companies and managed to get offers from top tech companies in the Bay Area - Google, Airbnb, Palantir, Dropbox, Lyft, and some startups.

It was a tedious process which I don't ever want to go through again. **I went through that process but with this handbook, you don't have to.** This handbook contains the essence of technical interviewing which will benefit you in your job hunt.

## Why would you read this?

This repository has **practical** content that covers all phases of a technical interview, from applying for a job to passing the interviews to offer negotiation. Technically competent candidates might still find the non-technical content helpful.

The information in this repository is condensed. Ultimately, the key to succeeding in technical interviews is consistent practice and I don't want to bore you with too many words. I tell you the minimum you need to know on how to go about navigating the interview process, you go and practice and land your dream job.

## Who is this for?

Whether you are a beginner to technical interviews or a seasoned engineer who has not been on the other side of the interviewing table in a while and want to get back into the game, the Tech Interview Handbook has got you covered.

If you are a busy engineer like most people are, this resource is for you. Nobody has time to do hundreds of LeetCode questions, and the good news is that you don't need to do that many to actually get the job at FAANG! I looked through hundreds of LeetCode questions and distilled the [best questions to practice](./best-practice-questions.md).
