---
id: questions-to-ask
title: Questions to ask
---

import InDocAd from './\_components/InDocAd';

Here are some good questions to ask at the end of the interview, extracted from various sources. The ones in **bold** are the ones that tend to make the interviewer go "That's a good question" and pause and think for a bit.

## General

- **What are you most proud about in your career so far?**
- **What is the most important/valuable thing you have learnt from working here?**
- How do your clients and customers define success?
- What would you change around here if you could?
- What are some weaknesses of the organization?
- What does a typical day look like for you?
- What do you think the company can improve at?
- How would you see yourself growing at this company in the next few years?
- Was there a time where you messed up and how was it handled?
- Why did you choose to come to this company?
- When you were last interviewing, what were some of your other options, and what made you choose this company?
- What was something you wish someone would have told you before you joined?
- What was your best moment so far at the company?

## Culture

- **What is the most frustrating part about working here?**
- **What is unique about working at this company that you have not experienced elsewhere?**
- **What is something you wish were different about your job?**
- How will the work I will be doing contribute to the organization's mission?
- What do you like about working here?
- What is your policy on working from home/remotely?
- (If the company is a startup) When was the last time you interacted with a founder? What was it regarding? Generally how involved are the founders in the day-to-day?
- Does the company culture encourage entrepreneurship? Could you give me any specific examples?

## Technical

These questions are suitable for any technical role.

- **What are the engineering challenges that the company/team is facing?**
- **What has been the worst technical blunder that has happened in the recent past? How did you guys deal with it? What changes were implemented afterwards to make sure it didn't happen again?**
- **What is the most costly technical decision made early on that the company is living with now?**
- **What is the most fulfilling/exciting/technically complex project that you've worked on here so far?**
- **I do / don't have experience in domain X. How important is this for me to be able to succeed?**
- How do you evaluate new technologies? Who makes the final decisions?
- How do you know what to work on each day?
- How would you describe your engineering culture?
- How has your role changed since joining the company?
- What is your stack? What is the rationale for/story behind this specific stack?
- Do you tend to roll your own solutions more often or rely on third party tools? What's the rationale in a specific case?
- How does the engineering team balance resources between feature requests and engineering maintenance?
- What do you measure? What are your most important product metrics?
- What does the company do to nurture and train its employees?
- How often have you moved teams? What made you join the team you're on right now? If you wanted to move teams, what would need to happen?
- What resources does the company have for new hires to study its product and processes? Are there specifications, requirements, documentation?
- There's "C++" (or Python, Swift or any other tech) in the job description. How will you estimate my proficiency in this tech in 3 months?
- How do you think my expertise would be relevant to this team? What unique value can I add?

<InDocAd/>

## Product

- Tell me about the main products of your company.
- What is the current version of product? (If it is v1.0 or similar - there could be a lot of chaos to work with)
- What products are your main competitors?
- What makes your product competitive?
- When are you planning to provide the next release? (If in several months, it would mean a lot of requirements specified in job description are not needed right now)
- Is the team growing, and what sort of opportunities will there be in the next year/3 years?
- What are your highest priorities right now? For example, new features, new products, solidifying existing code, reducing operations overhead?

## Management

These questions are suitable for asking Engineering Managers, especially useful for the Team Matching phase of Google interviews or post-offer calls that your recruiters set up with the various team managers.

- **How do you train/ramp up engineers who are new to the team?**
- **What does success look like for your team/project?**
- **What qualities do you look out for when hiring for this role?**
- **What are the strengths and weaknesses of the current team? What is being done to improve upon the weaknesses?**
- **Can you tell me about a time you resolved an interpersonal conflict?**
- How did you become a manager?
- How do your engineers know what to work on each day?
- What is your team's biggest challenge right now?
- How do you measure individual performance?
- How often are 1:1s conducted?
- What is the current team composition like?
- What opportunities are available to switch roles? How does this work?
- Two senior team members disagree over a technical issue. How do you handle it?
- Have you managed a poor performer at some point in your career before? What did you do and how did it work?
- Where do you spend more of your time, high performers or low performers?
- Sometimes there's a trade-off between what's best for one of your team members and what's best for the team. Give an example of how you handled this and why.
- Give an example of a time you faced a difficult mentoring/coaching challenge. What did you do and why?
- What is your management philosophy?
- What is the role of data and metrics in managing a team like ours?
- What role does the manager play in making technical decisions?
- What is an example of a change you have made in the team that improved the team?
- What would be the most important problem you would want me to solve if I joined your team?
- What opportunities for growth will your team provide?
- What would I work on if I joined this team and who would I work most closely with?

<InDocAd/>

## Leadership

These questions are intended for senior level management, such as CEO, CTO, VPs. Candidates who interview with startups usually get to speak with senior level management.

- How are you funded?
- Are you profitable? If no, what's your plan for becoming profitable?
- What assurance do you have that this company will be successful?
- Tell me about your reporting structure.
- How does the company decide on what to work on next?

## HR

- **How do you see this position evolving in the next three years?**
- **Who is your ideal candidate and how can I make myself more like them?**
- What concerns/reservations do you have about me for this position?
- What can I help to clarify that would make hiring me an easy decision?
- How does the management team deal with mistakes?
- If you could hire anyone to join your team, who would that be and why?
- How long does the average engineer stay at the company?
- Why have the last few people left?
- Have you ever thought about leaving? If you were to leave, where would you go?

## References

- [Business Insider](http://www.businessinsider.sg/impressive-job-interview-questions-2015-3/)
- [Lifehacker](http://lifehacker.com/ask-this-question-to-end-your-job-interview-on-a-good-n-1787624433)
- [Fastcompany](https://www.fastcompany.com/40406730/7-questions-recruiters-at-amazon-spotify-and-more-want-you-to-ask)
- [Questions I'm asking in interviews](http://jvns.ca/blog/2013/12/30/questions-im-asking-in-interviews/)
- [How to interview your interviewers](http://blog.alinelerner.com/how-to-interview-your-interviewers/)
- [How to Break Into the Tech Industry—a Guide to Job Hunting and Tech Interviews](https://haseebq.com/how-to-break-into-tech-job-hunting-and-interviews/)
- [A developer's guide to interviewing](https://medium.freecodecamp.org/how-to-interview-as-a-developer-candidate-b666734f12dd)
- [Questions I'm asking in interviews 2017](https://cternus.net/blog/2017/10/10/questions-i-m-asking-in-interviews-2017/)
- [What are good questions to ask during a software developer interview when asked "Do you have any questions now?"](https://www.quora.com/What-are-good-questions-to-ask-during-a-software-developer-interview-when-asked-do-you-have-any-questions-now/answer/John-L-Miller)
- [What are some good questions to ask when interviewing someone for a manager position?](https://www.quora.com/What-are-some-good-questions-to-ask-when-interviewing-someone-for-a-manager-position/answer/David-Seidman)
