---
id: ats-proof-template
title: Set up your ATS-proof resume template
description: Learn how to create an ATS-proof software engineering resume for FAANG
keywords:
  [
    FAANG,
    software engineering resume,
    step-by-step resume guide,
    software engineer resume,
    FAANG software engineer resume,
    ATS,
    ATS readability,
    ATS proof template,
  ]
---

Most companies these days automate their resume screening process through Applicant Tracking Systems (ATS). 75% of resumes sent to top companies are never seen by human eyes. Always ensure your resume is easily readable by an ATS to maximize job opportunities throughout your career.

:::tip Expert tip

[FAANG Tech Leads](https://www.faangtechleads.com?utm_source=techinterviewhandbook&utm_medium=referral&utm_content=ats_template&aff=1e80c401fe7e2) is currently offering resume templates and examples at **70% off**.

Their templates:

- Are created by ex-FAANG hiring managers based on top resumes received from hundreds of candidate applications
- Guarantee readability by FAANG ATS
- Cater to various experience levels

They also offer resume examples/references from candidates who have received multiple offers from FAANG companies - which are helpful in helping you craft content that meets the same bar. [Check it out](https://www.faangtechleads.com?utm_source=techinterviewhandbook&utm_medium=referral&utm_content=ats_template&aff=1e80c401fe7e2)!

:::

## Use Microsoft Word or Google Docs to create and edit your resume

**Do's**

- Submit your resume as a PDF file to preserve formatting, but always create it from Microsoft Word or Google Docs. It is important to ensure that the text in your resume is easily highlightable, which is a precondition for easy parsing.
- ATS tools are always trying to improve their readability of standard resume formats - hence the more commonplace your resume format is, the better.
- To maximize space on your resume, rather than using header or footers, reduce the margins of the page - narrow margins are 0.5 on each side.

**Don'ts**

- Do not use Photoshop, other graphic design tools or online resume builders to build your resume
- Do not use the header or footer sections in a Word/Google Docs file - reduce margins instead and just write the information in the body.

## Use a standard font of readable size

New fonts may convert letters into special characters which are not readable by the ATS. Fonts you should use - **Arial, Calibri, Garamond**.

Ensure your font size remains readable for humans later on in the hiring process - use a minimum size of **10px** for readability.

## Add sections with standard headings and ordering

ATS readers need to identify and parse standard types of information from your resume. Using standard header titles and ordering can help them do that better.

This is the order which has worked well for me and recommended by recruiters:

| Section | Heading Name |
| --- | --- |
| Professional summary | (Use resume headline as section title, for e.g. "Senior Software Engineer at Google with over 5 years of experience leading teams") |
| Contact information | "Contact Information" |
| Skills - programming languages, frameworks, etc. | "Skills" |
| Experience | "Work Experience" |
| Education (Note: if you are still in school or have less than 3 years of experience, you may put Education first) | "Education" |
| Projects | "Projects" |
| Other optional sections - e.g. Certifications, Awards, etc | "Awards and Accolades" / "Certifications" / "Awards, Accolades and Certifications" |

:::caution

Never add symbols to your headers to avoid ATS readability issues.

:::
