---
id: optimize-resume
title: Optimize your resume
description: Learn how to effectively optimize your software engineering resume for FAANG
keywords:
  [
    FAANG,
    software engineering resume,
    step-by-step resume guide,
    software engineer resume,
    FAANG software engineer resume,
    keyword optimization,
    ATS,
    ATS proof,
    job description,
  ]
toc_max_heading_level: 2
---

With the basic resume up, we can next try to optimize the resume content. Here are two must-haves to optimize your content:

## 1. Less is more

**Do's**

- Highlighting a few of your best achievements is better than including many "average" achievements in your resume
- Use only 1 page for your resume

**Don'ts**

- Do not list all your achievements just to showcase a greater quantity without filtering

## 2. Keyword optimization

Imagine you are a hiring manager or recruiter screening a resume while juggling many other tasks in your job - you simply won't have much time on each resume! When a hiring manager looks at a resume, they are in fact quickly scanning for keywords of skills or experiences that they value, before paying any additional attention to your resume.

Recruiters and ATS do that as well, but based on the job description that the hiring manager helped to write. That is why optimizing your resume based on job descriptions is very important.

:::info

Some ATS will determine the strength of your skills based on the frequency of a keyword in your resume, and others assign an estimated amount of experience for a skill based on its placement in your resume.

For instance, if your previous job experience was 3 years long and you mentioned handling Search engine marketing (SEM), the ATS will assume 5 years of SEM experience.

:::

### Include keywords from job descriptions into your resume

You should always analyze the job description for must-have and good-to-have skills or experiences and ensure the keywords are added to your resume.

Include them under the "Skills" section and pepper the same keywords into the "Work Experience" and "Education" sections. Be sure to closely imitate the language within the job description.

Remember to include the full version of common abbreviations as well. E.g. Amazon Web Services instead of AWS, Google Cloud Platform instead of GCP.

However, do not do keyword stuffing for the sake of it - always remember that the resume will be read by a recruiter or hiring manager eventually.

### Optimize keyword frequency and placement

Analyze the job description and determine how important each skill and experience is, then optimize the frequency of the keyword according to its importance.

:::tip Expert tip

While optimizing for every application is ideal, you can generalize your resume to a type of position.

1. Collate 3 to 5 job descriptions for that position
1. Copy and paste them into a `.txt` file and upload it into a free "word and phrase" frequency tool like [Online-Utility.org's Text Analyzer](https://www.online-utility.org/text/analyzer.jsp) to identify regularly used keywords
1. Incorporate skills and experiences that you have into the resume

:::

<!-- I have also prepared a list of fail-safe keywords you can use to pass most ATS screeners, segmented by type and seniority of software engineer. You can find it [here]. -->
