---
id: write-effective-content
title: Write effective resume content
description: Learn how to effectively write your software engineering resume for FAANG
keywords:
  [
    FAANG,
    software engineering resume,
    step-by-step resume guide,
    software engineer resume,
    FAANG software engineer resume,
    professional summary,
    skills,
    work experience,
    education,
    awards,
  ]
toc_max_heading_level: 2
---

import InDocAd from '../\_components/InDocAd';

Next, fill up your template!

It is daunting to start on a fresh slate, so I recommend you start by making a laundry list of bullet points under each section, then optimizing it accordingly. This prevents excessive attention placed on premature optimization.

**Do's for ATS readability**

- If a divider is required between information, use "|" (pipe character) or tabs
- Use simple bullet points

**Don'ts for ATS readability**

- Do not use images, pictures or diagrams
- Do not use tables

:::tip Expert tip

To maximize efficiency in applying for several job types, create and keep a "Master resume" updated which will basically contain an exhaustive list of all points under every section of your resume. When applying for each job, you can make a copy of the Master document and eliminate or optimize points as necessary.

:::

## 1. Professional summary

The professional summary, if written well, will be the most effective and important part of your resume. From my experience as an interviewer, I generally may not have the time to read into the detail of resumes - hence summaries which directly address why a candidate is a good fit for the job greatly improves their chances of capturing my attention.

**Start with a resume headline**

Always start with a concise, one line description of yourself

- Fewer than 10 words
- Summarizes your experience relevant to the job description

Examples:

- Software Engineer at Company X with strong fundamentals in front-end technologies

**Summarize your best selling points**

Below the resume headline, include a summary of yourself which expands on your resume headline.

- 4 or fewer points, in bullet or paragraph form
- Include most important skills and experiences relevant to the job applied, quantifying them where possible
- Keep in mind to answer the question of "Why am I a good fit for this job?" - while writing the summary

## 2. Contact information

**Must-haves**

- Name (Should be included at the very top of the resume)
- Personal phone number
  - Never include your work phone number here
- Location - City, State, Zip
  - Just enough for recruiters to determine if you are a local or international candidate
- Email address
  - Never include your work email here
  - I recommend Gmail if you are using other email services
- LinkedIn profile

**Good-to-haves**

- GitHub profile URL
- Personal website URL
- Stack Overflow profile URL
- Medium profile URL
- Competitive coding profile
  - Codechef
  - Hackerrank

If a divider is required between information, use "|" or tabs

Where relevant, indicate achievements in coding platforms, for example, max ratings, ranking, number of stars, badges.

## 3. Skills

Include programming languages and tech stacks:

Structure in the following manner:

> [Skill summary] : [List skills separated by "|"]

- Programming languages - If impressive, include your familiarity by the number of lines you have written, for example "Over 10,000 lines"
- Frameworks
- Databases

<InDocAd/>

## 4. Work experience

List your work experience in a familiar format and reverse chronological order. Every job listed should have:

The company, location, title, duration worked following this structure

> [Company or Organization], [Location] | [Job Title] | [Start and end dates formatted as MM/YYYY]

Example

> Facebook, Singapore | Front End Engineering Lead | 08/2018 - Present

List of top accomplishments, including:

- Scope of job and skills required
- Accomplishments listed following this structure
  - > [Accomplishment summary] : [Action] that resulted in [quantifiable outcome]

## 5. Education

Most software engineering jobs will require at least an undergraduate degree. However, unless you are a recent graduate or do not have much work experience, it should not be prioritized above your work experience.

Use the following format, eliminating information where it is not relevant:

> [Degree Name], [Year of Graduation - write expected graduation date if not graduated]<br/>[University Name], [Location]<br/>GPA: X.XX / 4.0 (List GPA if more than 3.50/4.00, or more than 4.3 under a 5-point system)<br/>List key achievements, including leadership positions, skills, societies, projects, awards, etc.

Example:

> BSc in Computing, Computer Science, Graduation Year 2015<br/> National University of Singapore, Singapore <br/>GPA: 3.82 / 4.00 (Magna cum laude)<br/>Dean's List, Valedictorian<br/>President of hacker society

## 6. Projects

Include at least 2 projects you have contributed to, outlining your key contributions. Always try to link your project name to GitHub or somewhere the hiring manager can view your project.

> [facebook/docusaurus](https://github.com/facebook/docusaurus) <br/>Maintainer and lead engineer for Docusaurus v2, a static site generator which powers the documentation of many of Meta’s Open Source Projects - React Native, Jest, Relay, Reason, etc. Used by 7.6k > projects on GitHub.

## 7. Awards, accolades and certifications

Only include achievements related to the job application and try to quantify your achievements. A good format to use would be

> [Year] [Quantification] [Competition]

Example

> 2016 | Best All-Round Product out of 50 teams | Facebook Hackathon
