import React from 'react';

export default [
  {
    name: 'Erin Teo',
    title: 'Front End Engineer, Facebook',
    thumbnail: 'https://avatars1.githubusercontent.com/u/5081708?s=460&v=4',
    quote: (
      <>
        Preparing for my first rounds of tech interviews was really daunting - I
        wasn't sure what to expect and where to start. This handbook together
        with the{' '}
        <a
          href="https://frontendinterviewhandbook.com"
          target="_blank"
          rel="noreferrer noopener">
          Front End Interview Handbook
        </a>{' '}
        was a great starting point for me. It clearly describes each part of the
        process and has tons of awesome tips and resources. With this handbook
        and lots of practice, I managed to get offers from Facebook, Dropbox and
        Amazon!
      </>
    ),
  },
  {
    name: 'Siddhesh Karekar',
    title: 'Software Engineer, Google',
    thumbnail: 'https://avatars1.githubusercontent.com/u/18223888?s=460&v=4',
    quote: (
      <>
        Most of us are familiar with having the prospect of having to grind tons
        of LeetCode problems before the interview, but I really wanted a sense
        of direction, an outline of sorts to prepare efficiently; I wanted to
        pick questions that covered all the important concepts one can be tested
        on. The Tech Interview Handbook provides just that; the Algorithms
        section was an absolutely invaluable resource and a great overall
        reference to brush up my fundamentals with the helpful hints and tips
        provided, and also solve some of the most popular questions categorized
        by type. I certainly have this handbook to thank for helping me land my
        dream job at Google!
      </>
    ),
  },
  {
    name: 'Zhenghao He',
    title: 'Senior Software Engineer, Instacart',
    thumbnail: 'https://github.com/zhenghaohe.png',
    quote: (
      <>
        Tech Interview Handbook was the best resource I used during my coding
        interview prep. Its structure and hand-picked questions and detailed
        explanations really set it apart from other resources out there. I
        helped me go into my interviews with confidence. I ended up landing
        offers at Meta, Amazon, Twitch, Microsoft, Coinbase, Splunk, etc. I
        highly recommend Tech Interview Handbook to anyone looking to secure an
        offer from big tech companies.
        <br />
        <br />
        I've learnt a few things and blogged about them on{' '}
        <a href="https://zhenghao.io" rel="noopener">
          https://zhenghao.io
        </a>
        , check them out if you're interested!
      </>
    ),
  },
  {
    name: 'Kevin Huang',
    title: 'Software Engineer, Uber',
    thumbnail: 'https://avatars1.githubusercontent.com/u/25380336?s=460&v=4',
    quote: (
      <>
        The Tech Interview Handbook played a crucial role in the success of my
        previous job search. The contents are carefully curated and well
        organized. It served as an excellent roadmap for my interview prep.
        <br />
        <br />
        In addition to the thorough Data Structures and Algorithms section, the
        handbook also provides a lot of resources on other aspects of the
        application process that helped me see the tech interviews in a more
        holistic way. My favorite non-technical part was "Questions To Ask"! I
        used quite a few insightful questions from there to challenge and
        impress my interviewers. The results were great!
        <br />
        <br />
        With the help of Tech Interview Handbook, I was able to land offers from
        Google, Amazon, Uber and several other great companies. Really
        appreciate the contributors for putting out such quality content for the
        community. I'd wholeheartedly recommend this handbook to anyone!
      </>
    ),
  },
  {
    name: 'Zongran Mo',
    title: 'Software Engineer, Abnormal Security',
    thumbnail: 'https://avatars.githubusercontent.com/u/19870898?s=400&v=4',
    quote: (
      <>
        I have not been preparing much for my interviews before my final year in
        university. As I set my sights on my full time job, I referred heavily
        to this handbook about things to prepare and look out for during my
        applicaion. It has helped me so much in many stages of my application.
        My personal favorite is the best algorithm practice questions, which is
        helpful in the future if I want to switch jobs.
        <br />
        <br />
        With the help of this handbook, I successfully land offers from
        Facebook, Quora, Abnormal Security and a few more established companies.
        Highly recommend any tech job applicants to refer to this handbook.
      </>
    ),
  },
];
